#include <stdio.h>
#include <string.h>

char *filter[] = {
//	{""},
	{"[armeabi-v7a] SharedLibrary"},
	{"[armeabi-v7a] Install"},
	{"[dex] Pre-Dexing"},
	{"Buildfile:"},
	{"[gettype] Project Type:"},
	{"[getbuildtools] Using latest Build Tools:"},
	{"[gettarget] Project Target:"},
	{"-set-mode-check:"},
	{"-set-release-mode:"},
	{"-release-obfuscation-check:"},
	{"-pre-build:"},
	{"-check-env:"},
	{"[checkenv] Android SDK Tools"},
	{"[checkenv] Installed at"},
	{"-setup:"},
	{"-build-setup:"},
	{"-post-compile:"},
	{"[gettarget] API level:"},
	{"[dependency] Library dependencies:"},
	{"[dependency] No Libraries"},
	{"[dependency] ------------------"},
	{"[subant] No sub-builds"},
	{"-code-gen:"},
	{"[mergemanifest] Manifest merger disabled."},
	{"[buildconfig] No need to generate new BuildConfig"},
	{"[aidl] No AIDL files to compile"},
	{"[aapt] Generating resource IDs"},
	{"D:\\AndroidDev\\adt-bundle-windows-x86_64-20131030\\sdk\\tools"},
	{"[mergemanifest] Merging AndroidManifest"},
	{"[mergemanifest] Found Deleted Target File"},
	{"-pre-compile:"},
	{"[dx] Merged dex A"},
	{"[dex] Converting compiled"},
	{"[dex] Found Deleted Target File"},
	{"-post-package:"},
	{"-release-prompt-for-password:"},
	{"-release-nosign:"},
	{"-release-sign:"},
	{"[zipalign] Running zip align on final apk..."},
	{"-post-build:"},
	{"release:"},
	{"[propertyfile]"},
	{"[echo]"},
	{"[apkbuilder] Found Deleted Target File"},
	{"[apkbuilder] Creating"},
	{"-package:"},
	{"-package-resources:"},
	{"[aapt] Found Deleted Target File"},
	{"[aapt] Creating full resource package..."},
	{"-crunch:"},
	{"[crunch] Crunching PNG Files"},
	{"[crunch] To destination dir"},
	{"[crunch] Crunched"},
	{"-obfuscate:"},
	{"-dex:"},
	{"[dex] input:"},
	{"[dex] Using Pre-Dexed"},
	{0}
};

int filterLine( char *buff )
{
	int idx = 0;
	while( filter[idx] )  {
		if( strstr( buff, filter[ idx++ ] ) )
			return 1;
	}
	return 0;
}

int main( int argc, char *argv[] )
{
	FILE *in;
	char buff[ 256 ];
	int len, idx, goodCompile = -1, ret = 0;
				
	while( fgets( buff, 255, stdin ) )  {
		len = strlen( buff );
		if( strstr( buff, "make.exe: ***" ) && strstr( buff, "Error 1") ) 
			ret = 1;
		if( strstr( buff, "Android NDK: Aborting" ) ) 
			ret = 1;
		if( len < 3 || filterLine( buff ) )
			continue;
		if( len == 14 && !strncmp( buff, "[dependency]", 12 ) )
			continue;
		if( len == 10 && !strncmp( buff, "-compile:", 9 ) )  {
			printf("Compiling...\n");
			continue;
		}
		if( strstr( buff, "BUILD SUCCESSFUL" ) )  {
			goodCompile = 1;
			continue;
		}
		if( strstr( buff, "BUILD FAILED" ) )  {
			goodCompile = 0;
			continue;
		}
		if( strstr( buff, "Total time:" ) )  {
			if( goodCompile == 1 )
				printf("Build Successful - %s", buff );
			else if( !goodCompile )
				printf("Build Failed - %s", buff );
			else
				printf("%s", buff );
			continue;
		}
		if( strstr( buff, "[javac] Compiling") && strstr( buff, "source file to") )
			continue; 
		printf("%s", buff );
	}
	
	return ret;
}
